#include <iostream>
#include <cstring>

// zkuste si odkomentovat atribut m_dummy a sledujte jak se zmeni velikost
// tohoto typu - je to proto, ze implicitne se ukazatele zarovnavaji na
// adresy delitelne bitazi architektury - u x86_64 tedy 8
class c_compatible_class {
public:
    c_compatible_class(void * a):m_pointer(a){ ; }
//    c_compatible_class(void * a):m_pointer(a), m_dummy('c'){ ; }
    ~c_compatible_class(){ ; }

private:
    void * m_pointer;
//    char m_dummy;
};

class pure_cpp_class {
public:
    pure_cpp_class(char a):m_dummy(a){ ; }
    virtual ~pure_cpp_class(){ ; }

private:
    char m_dummy;
};

// atribut packed se zbavi vsech vycpavek, pozorujte rozdil oproti prvni tride
class packed_class {
public:
    packed_class(int a):m_number(a){ ; }
    virtual ~packed_class(){ ; }

private:
    int m_number;
} __attribute__((packed));

class packed_hw_compatible {
public:
    packed_hw_compatible(unsigned char blink, unsigned char background, unsigned char foreground, char character)
        :m_blink(blink), m_background(background), m_foreground(foreground), m_character(character)
    { ; }
    ~packed_hw_compatible(){ ; }

private:
    int m_blink:1;
    int m_background:1;
    int m_foreground:1;
    char m_character:8;
} __attribute__((packed));

int main(){
    std::cout << "velikost typu c_compatible_class je " << sizeof(c_compatible_class) << "bytu" << std::endl;
    std::cout << "neobsahuje totiz zadne veci specificke pro C++ a tedy plati pro urceni velikosti stejna pravidla, jako pro C" << std::endl << std::endl;

    std::cout << "velikost typu pure_cpp_class je " << sizeof(pure_cpp_class) << "bytu" << std::endl;
    std::cout << "obsahuje uz totiz prvky specificke pro C++ (ukazatel na vtable) a tedy je nutno tento skryty ukazatel vzit v uvahu" << std::endl << std::endl;

    std::cout << "velikost typu packed_class je " << sizeof(packed_class) << "bytu" << std::endl;
    std::cout << "pokud se chceme zbavit vycpavek v pameti objektu, pouzijeme atribut packed, "
        "zapisovany __attribute__((packed)) mezi strednik a uzavirajici slozenou zavorku za tridou; jedna se "
        "o vec specifickou pro kompilator" << std::endl << std::endl;

    std::cout << "velikost typu packed_hw_compatible je " << sizeof(packed_hw_compatible) << "bytu" << std::endl;
    std::cout << "jedna se o realny priklad znaku pro textovy rezim VGA karty (http://en.wikipedia.org/wiki/VGA-compatible_text_mode)" << std::endl << std::endl;

    return 0;
}
