#include <iostream>
#include <cstring>

class A {
public:
    A(int a):m_number(a){ std::cout << "konstruktor A (" << this << ")" << std::endl; }
    virtual ~A(){ std::cout << "destruktor A (" << this << ")" << std::endl; }

    virtual int get_number() const { return m_number; }
    virtual void set_number(int a){ m_number = a; }

private:
    int m_number;
};

int main(){
    // DULEZITE: teto prasarne se v praxi vyhybejte, slouzi jen pro demonstraci

    const int POCET_PRVKU = 20;

    // pro toto reseni potrebujeme existujici instanci objektu typu A
    A existujici_instance_a(20);

    // nyni naalokujeme patricnou oblast pameti
    // funkce static_cast je takove pokrocilejsi pretypovani, podobne tomu
    // ktere znate z jazyka C
    // dale se zde vola manualne operator new kteremu je dano za ukol
    // naalokovat sizeof(A) bytu v pameti - tyto jsou inicializovany na 0
    A * pole_a_hack = static_cast<A*>(operator new(sizeof(A) * POCET_PRVKU));
    // coz znamena, ze tyto dva radky jsou logicky identicke
    //A * pole_a_hack = static_cast<A*>(calloc(POCET_PRVKU, sizeof(A)));

    // tento kod by zpusobil pad programu, protoze pamet ve ktere ma byt
    // ukazatel na tabulku virtualnich metod je ve skutecnosti plna nul,
    // tedy ukazatel na tabulku virtualnich metod je roven NULL
    // pole_a_hack[0].set_number(30);

    // nyni tedy "vylecime" ukazatele na tabulku virtualnich metod v nove
    // alokovanem poli
    for (int i = 0; i < POCET_PRVKU; i++){
        // ukazatel na vtable je umisten na zacatku pameti objektu
        // velikost vsech ukazatelu je stejna (existuje jen jedna vyjimka,
        // ktera se vas netyka)
        memcpy(pole_a_hack+i, &existujici_instance_a, sizeof(int *));
    }

    // nasledujici radek zpusobi pad, pamet nebyla totiz alokovana jako pole
    // objektu typu A, ale jako souvisly kus pameti jednotlivych byte (tzn. char)
    // delete[] pole_a_hack;
    delete (char *)pole_a_hack;

    return 0;
}
